#include <dune/common/fvector.hh>
#include <dune/istl/bvector.hh>

typedef Dune::BlockVector<Dune::FieldVector<double, 1>> SingletonVectorType;

// {{{ 2D
typedef Dune::FieldVector<double, 2> SmallVector2;
typedef Dune::BlockVector<SmallVector2> VectorType2;

template void print_evolution<SingletonVectorType, VectorType2>(
    Dune::BitSetVector<1> const &frictionalNodes,
    SingletonVectorType const &state, VectorType2 const &displacement,
    Dune::VirtualFunction<double, double> const &function, int run, double time,
    std::ostream &octave_writer);
// }}}

// {{{ 3D
typedef Dune::FieldVector<double, 3> SmallVector3;
typedef Dune::BlockVector<SmallVector3> VectorType3;

template void print_evolution<SingletonVectorType, VectorType3>(
    Dune::BitSetVector<1> const &frictionalNodes,
    SingletonVectorType const &state, VectorType3 const &displacement,
    Dune::VirtualFunction<double, double> const &function, int run, double time,
    std::ostream &octave_writer);
// }}}
